unit nactixml;

interface
uses classes, sysutils, strutils, messages, dialogs;


procedure fillcs;
function getxmlvalue(const s:string;start:integer;name:string):string;
procedure loadlist(const dir:string);
procedure nacticesty;
procedure nactimesta;
procedure nactispotreby;
function findmesto(const nazev:string):integer;
function getspotreba(const v:real):real;
function findcesta(odkud,kam:integer):integer;

type tmesto=record
             nazev:string;
             x,y:integer;
            end;

     tcesta=record
             odkud,kam:integer;
             doba,vzdalenost,rychlost, cena:real;

            end;

     tspotreba=record
                rychlost:real;
                spotreba:real;
               end;

     tmesta=array of tmesto;
     tcesty=array of tcesta;
     tspotreby=array of tspotreba;

var mesta:tmesta;
    spotreby:tspotreby;
    cesty:tcesty;
    xmllist:tstringlist;
    
implementation

function strtofloat2(s:string):real;
var i:integer;
begin
 for i:=1 to length(s) do
  if s[i]='.' then s[i]:=',';
 result:=strtofloat(s);
end;

function findmesto(const nazev:string):integer;
var i:integer;
begin
 for i:=0 to high(mesta) do
  if ansiuppercase(mesta[i].nazev)=ansiuppercase(nazev) then
  begin
   result:=i;
   exit;
  end;
 result:=-1;
end;

function getspotreba(const v:real):real;
var i:integer;
begin
 for i:=0 to high(spotreby) do
  if spotreby[i].rychlost=v then
  begin
   result:=spotreby[i].spotreba;
   exit;
  end;
 result:=-1;
end;

function findcesta(odkud,kam:integer):integer;
var i:integer;
begin
 for i:=0 to high(cesty) do
  if ( (cesty[i].odkud=odkud) and ( cesty[i].kam=kam ) )
  or ( (cesty[i].odkud=kam) and ( cesty[i].kam=odkud ) ) then
   begin
    result:=i;
    exit;
   end;

 result:=-1;
end;

function getxmlvalue(const s:string;start:integer;name:string):string;
var xod,xdo:integer;
begin
 xod:=posex(name,s,start);
 xdo:=posex('/'+name,s,start);
 if (xod=0) and (xdo=0) then begin result:='';exit;end;
 if xod>xdo then xdo:= posex('/'+name,s,xod+2);
 if xdo=0 then begin result:='';exit;end;
 inc(xod,length(name)+1);
 dec(xdo,2);
 result:=copy(s,xod,xdo-xod+1);
end;

procedure loadlist(const dir:string);
begin
 try
  xmllist:=tstringlist.Create;
  xmllist.LoadFromFile(dir);
 except
  showmessage('Chyba pri nacitani xmlka');
 end;

end;


procedure nactimesta;
var index:integer;mesto:string;
begin
 setlength(mesta,0);
 index:=1;
 mesto:=getxmlvalue(xmllist.Text,index,'mesto');
 while mesto<>'' do
 begin
  setlength(mesta,length(mesta)+1);
  with mesta[high(mesta)] do
  begin
   x:=strtoint(getxmlvalue(mesto,1,'polohaX'));
   y:=strtoint(getxmlvalue(mesto,1,'polohaY'));
   nazev:=getxmlvalue(mesto,1,'nazev');
  end;
  index:=index+length(mesto)+10;             //+8=length('</mesto>');
  mesto:=getxmlvalue(xmllist.Text,index,'mesto');
 end;
end;

procedure nacticesty;
var index:integer;cesta,s:string;
begin
 setlength(cesty,0);
 index:=pos('cesty',xmllist.text);
 cesta:=getxmlvalue(xmllist.Text,index,'cesta');
 while cesta<>'' do
 begin
  setlength(cesty,length(cesty)+1);
  with cesty[high(cesty)] do
  begin
   odkud:=findmesto(getxmlvalue(cesta,1,'z'));
   kam:=findmesto(getxmlvalue(cesta,1,'do'));
   if kam=-1 then kam:=41;
   vzdalenost:=strtofloat2(getxmlvalue(cesta,1,'vzdalenost'));
   rychlost:=strtofloat2(getxmlvalue(cesta,1,'prumernaRychlost'));
  end;
  index:=index+length(cesta)+15;
  cesta:=getxmlvalue(xmllist.Text,index,'cesta');
 end;
end;

procedure nactispotreby;
var index:integer;spotreb,s:string;
begin
 setlength(spotreby,0);
 index:=pos('spotreby',xmllist.text);
 spotreb:=getxmlvalue(xmllist.Text,index,'spotreba');
 while spotreb<>'' do
 begin
  setlength(spotreby,length(spotreby)+1);
  with spotreby[high(spotreby)] do
  begin
   spotreba:=strtofloat2(getxmlvalue(spotreb,1,'litru'));
   rychlost:=strtofloat2(getxmlvalue(spotreb,1,'rychlost'));
  end;
  index:=index+length(spotreb)+10;
  spotreb:=getxmlvalue(xmllist.Text,index,'spotreba');
 end;
end;

procedure fillcs;
var i:integer;
begin
 for i:=0 to high(cesty) do
 with cesty[i] do
 begin
  cena:=getspotreba(rychlost)*vzdalenost/100;
  doba:=vzdalenost/rychlost;
 end;
end;


end.
